routes/web.php
<?php

use App\Http\Controllers\Admin\ComicController as AdminComicController;
use App\Http\Controllers\Guest\ComicController as GuestComicController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::prefix('Admin')->name('Admin.pages.')->group(function () {
    Route::get('/', function () {
        return view('Admin.pages.home');
    })->name('home');
    
    Route::resource('comics',AdminComicController::class);

    Route::get('/characters', function () {
        return view('Admin.pages.characters');
    })->name('characters');

    Route::get('/movies', function () {
        return view('Admin.pages.movies');
    })->name('movies');

    Route::get('/tv', function () {
        return view('Admin.pages.tv');
    })->name('tv');

    Route::get('/games', function () {
        return view('Admin.pages.games');
    })->name('games');

    Route::get('/collectibles', function () {
        return view('Admin.pages.collectibles');
    })->name('collectibles');

    Route::get('/videos', function () {
        return view('Admin.pages.videos');
    })->name('videos');

    Route::get('/fans', function () {
        return view('Admin.pages.fans');
    })->name('fans');

    Route::get('/news', function () {
        return view('Admin.pages.news');
    })->name('news');

    Route::get('/shop', function () {
        return view('Admin.pages.shop');
    })->name('shop');
});

Route::prefix('')->name('Guest.pages.')->group(function () {
    Route::get('/', function () {
        return view('Guest.pages.home');
    })->name('home');

    Route::get('/comics', [GuestComicController::class , 'index'])->name('comics');

    Route::get('/characters', function () {
        return view('Guest.pages.characters');
    })->name('characters');

    Route::get('/movies', function () {
        return view('Guest.pages.movies');
    })->name('movies');

    Route::get('/tv', function () {
        return view('Guest.pages.tv');
    })->name('tv');

    Route::get('/games', function () {
        return view('Guest.pages.games');
    })->name('games');

    Route::get('/collectibles', function () {
        return view('Guest.pages.collectibles');
    })->name('collectibles');

    Route::get('/videos', function () {
        return view('Guest.pages.videos');
    })->name('videos');

    Route::get('/fans', function () {
        return view('Guest.pages.fans');
    })->name('fans');

    Route::get('/news', function () {
        return view('Guest.pages.news');
    })->name('news');

    Route::get('/shop', function () {
        return view('Guest.pages.shop');
    })->name('shop');
});

app/Models/Comic.php
<?php

/*
|--------------------------------------------------------------------------
| Comic Class
|--------------------------------------------------------------------------
|
| A class that represents a comic istance
|
*/

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Comic extends Model
{
    use HasFactory;
    
    protected $fillable = array('title' , 'description' , 'thumb' , 'price' , 'series' , 'sale_date' , 'type');
}

app/Http/Controllers/Admin/ComicController.php
<?php

/*
|--------------------------------------------------------------------------
| Comic Controller in Admin
|--------------------------------------------------------------------------
|
| A controller for the istance Comic
|
*/

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Comic;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;

class ComicController extends Controller
{
    /**
     * Display a listing of the resource.
     *  
     * @param Comic $comic 
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $comics = Comic::all();
        
        return view('Admin.pages.comics.index', compact('comics'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $defaultComic = new Comic();
        return view('Admin.pages.comics.create' , compact('defaultComic'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request, Comic $comic)
    {
        $currentDate = Carbon::now()->toDateString();
        $formData = $request->validate([
                "title"=> ["required","between:2,255", Rule::unique('comics','title')->ignore($comic)],
                "description" => "required|min:10",
                "price" => "between:0.1,999999.99",
                "series" => "required|between:2,255",
                "sale_date" => "before:$currentDate",
                "type" => "required|between:2,255",
            ],
            [
                'title.required' => 'Il titolo deve essere inserito obbligatoriamente',
                'series.required' => 'La serie deve essere specificata',
                'series.type' => 'Il tipo di fumetto deve essere specificato',
                'description.required' => 'Deve inserire ancora una descrizione(min= 10 caratteri) per il fumetto',
                'description.min' => 'La descrizione non è abbastanza lunga(min=10 caratteri)',
                'sale_date.before' => 'La data non può essere uguale o superiore a quella attuale',
                'title.between' => 'Il titolo deve avere un numero di caratteri compreso tra 2 e 255',
                'series.between' => 'La serie deve avere un numero di caratteri compreso tra 2 e 255',
                'type.between' => 'Il tipo del fumetto deve avere un numero di caratteri compreso tra 2 e 255',
                'price.between' => 'Il prezzo deve essere compreso tra 0.1 e 999999.99',
            ]
        );

        $newComic = new Comic();
        $newComic->fill($formData);
        $newComic->save();

        return redirect()->route('Admin.pages.comics.show',$newComic->id)->with('message' , "$newComic->title has been created");
    }

    /**
     * Display the specified resource.
     *
     * @param  Comic $comic
     * @return \Illuminate\Http\Response
     */
    public function show(Comic $comic)
    {
        return view('Admin.pages.comics.show',compact("comic"));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Comic $comic
     * @return \Illuminate\Http\Response
     */
    public function edit(Comic $comic)
    {
        return view('Admin.pages.comics.edit',compact("comic"));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Comic $comic)
    {

        $currentDate = Carbon::now()->toDateString();
        $formData = $request->validate([
            "title"=> ["required","between:2,255", Rule::unique('comics','title')->ignore($comic)],
            "description" => "required|min:10",
            "price" => "between:0.1,999999.99",
            "series" => "required|between:2,255",
            "sale_date" => "before:$currentDate",
            "type" => "required|between:2,255",
        ],
        [
            'title.required' => 'Il titolo deve essere inserito obbligatoriamente',
            'series.required' => 'La serie deve essere specificata',
            'series.type' => 'Il tipo di fumetto deve essere specificato',
            'description.required' => 'Deve inserire ancora una descrizione(min= 10 caratteri) per il fumetto',
            'description.min' => 'La descrizione non è abbastanza lunga(min=10 caratteri)',
            'sale_date.before' => 'La data non può essere uguale o superiore a quella attuale',
            'title.between' => 'Il titolo deve avere un numero di caratteri compreso tra 2 e 255',
            'series.between' => 'La serie deve avere un numero di caratteri compreso tra 2 e 255',
            'type.between' => 'Il tipo del fumetto deve avere un numero di caratteri compreso tra 2 e 255',
            'price.between' => 'Il prezzo deve essere compreso tra 0.1 e 999999.99',
        ]
    );

        $comic->update($formData);

        return redirect()->route('Admin.pages.comics.show',$comic->id);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  Comic $comic
     * @return \Illuminate\Http\Response
     */
    public function destroy(Comic $comic)
    {
        $comic->delete();
        return redirect()->route('Admin.pages.comics.index')->with('message' , "$comic->title has been deleted");
    }
}

app/Http/Controllers/Guest/ComicController.php
<?php

/*
|--------------------------------------------------------------------------
| Comic Controller in Guest
|--------------------------------------------------------------------------
|
| A controller for the istance Comic
|
*/

namespace App\Http\Controllers\Guest;

use App\Http\Controllers\Controller;
use App\Models\Comic;
use Illuminate\Http\Request;

class ComicController extends Controller
{
    /**
     * Display a listing of the resource.
     *  
     * @return \Illuminate\Http\Response
     */
    
    public function index()
    {
        $comics = Comic::all();
        
        return view('Guest.pages.comics', compact('comics'));
    }
}

resources/views/Admin/pages/comics/create.blade.php
{{-- 
|--------------------------------------------------------------------------
| Comics create in Admin
|--------------------------------------------------------------------------
|
| This is the create 'Comics' section of the website
| available to the Admin.
|
--}}

@extends('layouts.app', ["currentUserType" => "Admin" , "otherUserType" => "Guest"])

@section('title' , 'Laravel DC Comics - Admin-Section')

@section('main-content')
@include('Admin.pages.comics.partials.form',["route" => "Admin.pages.comics.store"  , "formMethod" => "POST" , "comic" => $defaultComic])
@endsection

resources/views/Admin/pages/comics/edit.blade.php
{{-- 
|--------------------------------------------------------------------------
| Comics edit in Admin
|--------------------------------------------------------------------------
|
| This is the edit 'Comics' section of the website
| available to the Admin.
|
--}}

@extends('layouts.app', ["currentUserType" => "Admin" , "otherUserType" => "Guest"])

@section('title' , 'Laravel DC Comics - Admin-Section')
@section('main-content')

@include('Admin.pages.comics.partials.form',["route" => "Admin.pages.comics.update"  , "formMethod" => "PUT" , "comic" => $comic]);
@endsection

resources/views/Admin/pages/comics/index.blade.php
{{-- 
|--------------------------------------------------------------------------
| Comics index in Admin
|--------------------------------------------------------------------------
|
| This is the index 'Comics' section of the website
| available to the Admin.
|
--}}

@extends('layouts.app', ["currentUserType" => "Admin" , "otherUserType" => "Guest"])

@section('title' , 'Laravel DC Comics - Admin-Section')

@section('main-content')
@php
$tableElements=[
    'Id',
    'Title',
    'Description',
    'Thumb',
    'Price',
    'Sale_Date',
    'Type',
    '#'
];    
@endphp

@if (session('message'))
    <span>{{session('message')}}</span>
@endif

<table>
    <thead>
        <tr>
            @foreach ($tableElements as $tableEl)
                <th>{{$tableEl}}</th>
            @endforeach
        </tr> 
    </thead>
    <tbody>
        @foreach ($comics as $comic)
            <tr>
                <td>{{$comic->id}}</td>
                <td>{{$comic->title}}</td>
                <td>{{$comic->description}}</td>
                <td>{{$comic->thumb}}</td>
                <td>{{$comic->price}}&dollar;</td>
                <td>{{$comic->sale_date}}</td>
                <td>{{$comic->type}}</td>
                <td>
                    <a href="{{route('Admin.pages.comics.show' , $comic->id)}}">Show</a>
                    <a href="{{route('Admin.pages.comics.edit' , $comic->id)}}">Edit</a>

                    <form action="{{route('Admin.pages.comics.destroy' , $comic->id)}}" method="POST" data-form-destroy data-element-name = '{{$comic->title}}' >
                        @csrf
                        @method('DELETE')
                        <button type="submit">Delete</button>
                    </form>
                </td>
            </tr>
        @endforeach
    </tbody>
</table> 
@endsection

@section('scripts')
@vite('resources/js/Admin/deleteComicElement.js')
@endsection

resources/views/Admin/pages/comics/show.blade.php
{{-- 
|--------------------------------------------------------------------------
| Comics show in Admin
|--------------------------------------------------------------------------
|
| This is the show 'Comics' section of the website
| available to the Admin.
|
--}}

@extends('layouts.app', ["currentUserType" => "Admin" , "otherUserType" => "Guest"])

@section('title' , 'Laravel DC Comics - Admin-Section')

@section('main-content')
@php
    $listElements = [
        'title',
        'description',
        'price',
        'sale_date',
        'type',
    ]
@endphp

@if (session('message'))
    <span>{{session('message')}}</span>
@endif

<article class="my_card">
    <div class="my_img-container">
        <img src="{{$comic->thumb}}" alt="{{$comic->series}}" title="{{$comic->series}}">
    </div>
    
    <ul>
        @foreach ($listElements as $listEl)
            <li>{{$comic->$listEl}}</li> 
        @endforeach
    </ul>
</article>
@endsection